/*
    $Id: log.c,v 1.4 2001/11/01 20:55:50 sensei Exp $

    Copyright (C) 2000-2001  Marko Zivanovic
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
     
#ifndef lint
static char vcid[] __attribute__ ((__unused__)) = "$Id: log.c,v 1.4 2001/11/01 20:55:50 sensei Exp $";
#endif /* lint */

#include "log.h"

int _log_syslog = 0;

void open_log ()
{
  if (strncasecmp (log_file, "syslog", 6) == 0) {
    /*  log output goes to syslog */
    openlog (PACKAGE, LOG_PID, LOG_USER);
    _log_syslog = 1;
  } else {
    /*  open log file */
    flog = (FILE*) fopen (log_file, "at");
    if (flog == NULL) {
      flog = stderr;
      logmsg (LOG_ERR, "error opening log file: %s", strerror (errno));
      logmsg (LOG_INFO, "redirecting log output to stderr");
    }
  }
  return;
}

void logmsg (int level, const char *format, ...)
{
  va_list var;
  char buff[1024], tmp[128], type[128];
  time_t t;

  va_start (var, format);
  vsprintf (buff, format, var);
  va_end (var);

  if (_log_syslog == 1) {
    syslog (level, buff);
  } else {
    switch (level) {
    case LOG_EMERG: { strcpy (type, "emergency"); break; }
    case LOG_ALERT: { strcpy (type, "alert"); break; }
    case LOG_CRIT: { strcpy (type, "critical"); break; }
    case LOG_ERR: { strcpy (type, "error"); break; }
    case LOG_WARNING: { strcpy (type, "warning"); break; }
    case LOG_NOTICE: { strcpy (type, "notice"); break; }
    case LOG_INFO: { strcpy (type, "info"); break; }
    case LOG_DEBUG: { strcpy (type, "debug"); break; }
    }
    time (&t);
    sprintf (tmp, "%s", ctime (&t));
    tmp[strlen (tmp) - 1] = 0;
    fprintf (flog, "%s %s: %s\n", tmp, type, buff);
    if ((flog != NULL) && (flog != stderr))
      printf ("%s: %s\n", type, buff);
    fflush (flog);
  }
  return;
}
